package Clone;

#############################
### CLONE data structures ###
#############################

# this is used when we want to extract data
# from magic tied variables.

sub dclone {
    my @args = map(_dclone($_), @_);
    return wantarray ? @args : $args[0];
}

sub _dclone {
    my $ref = shift;
    my $ref_type = ref($ref) || return $ref;

    if($ref_type eq 'HASH') {
        return { map { $_ => _dclone($ref->{$_}) } (keys %$ref) };
    } elsif ($ref_type eq 'ARRAY') {
        return [ map(_dclone($_), @$ref) ];
    } else {
        my $clone = _dclone($$ref);
        return \$clone;
    }
}

1;
