# Scalar.pm
#
# Author: Liraz Siri <liraz@hushmail.com>
#
# Copyright (c) 1999 Liraz siri <liraz@hushmail.com>, Ariel, Israel,
#               All rights reserved.
#
# Created: Fri Apr 23 05:35:14 IDT 1999
#
# VRS scalar type tie magic.

package Tie::VRS::Scalar;

use strict;
use Tie::VRS::Base;
use vars qw(@ISA);

@ISA = qw(Tie::VRS::Base);

sub init {
    my ($self, $var) = @_;
    $self->STORE($var) if defined $var;
}

*new = \&TIESCALAR;
sub TIESCALAR {
    my ($class, @args) = @_;
    my $self = bless {}, $class;
    $self->type('SCALAR');
    $self->init(@args);
    return $self;
}

sub fetch {
    my $self = shift;
    my $ref = $self->ref;
    return $$ref;
}

sub FETCH {
    my $self = shift;
    return $self->enchant_ref_cached || $self->enchant_ref($self->fetch);
}

sub store {
    my ($self, $var) = @_;
    my $ref = $self->ref;
    $$ref = $var;
    $self->changed;
    return $var;
}

sub STORE {
    my ($self, $var) = @_;
    $self->enchant_unref;
    $self->store($var);
    return $self->enchant_ref($var);
}

1;
